// Fill out your copyright notice in the Description page of Project Settings.

#include "ViveportSDKPrivatePCH.h"
#include "ViveportToken.h"
#include "viveport_api.h"
#include <string>

static ViveportApiStatus* is_token_ready_status;
static ViveportApiStatus2* get_session_token_status;

void IsTokenReadyHandler(int nResult);
void GetSessionTokenHandler(int nResult, const char* message);

void UViveportToken::IsReady(ViveportApiStatus *callback)
{
#if PLATFORM_WINDOWS
    int ret = 0;
    if (FViveportSDKModule::IsAvailable())
    {
        is_token_ready_status = callback;
        ViveportToken()->IsReady(IsTokenReadyHandler);
    }
#endif
}

void UViveportToken::GetSessionToken(ViveportApiStatus2 *callback)
{
#if PLATFORM_WINDOWS
    if (FViveportSDKModule::IsAvailable())
    {
        get_session_token_status = callback;
        ViveportToken()->GetSessionToken(GetSessionTokenHandler);
    }
#endif
}

void IsTokenReadyHandler(int nResult)
{
    return nResult == 0 ? is_token_ready_status->OnSuccess() : is_token_ready_status->OnFailure(nResult);
}

void GetSessionTokenHandler(int nResult, const char* message)
{
    if (nResult == 0)
    {
        UE_LOG(LogTemp, Display, TEXT("Session token: %s"), *FString(UTF8_TO_TCHAR(std::string(message).c_str())));
        get_session_token_status->OnSuccess(FString(message));
    }
    else
    {
        UE_LOG(LogTemp, Display, TEXT("Get session fail, code: %d, msg: %s"), nResult, *FString(UTF8_TO_TCHAR(std::string(message).c_str())));
        get_session_token_status->OnFailure(nResult, FString(message));
    }
}

